//Key gpio_isr_handler

static void IRAM_ATTR gpio_isr_handler(void *arg)
{
    //debounce via button_pressed, avoid toggling by glitches on the button port due to power switches by next_switch_delay
    if (button_pressed || next_switch_delay || startup_in_progress)
        return;
    button_pressed = 1;
    delay_count = 5;
    return;
} 

//ISR called once a second. 
//Counts down timer and a one-minute-timer for blocking of planned switch actions
void hw_timer_callback1(void *arg)
{
    if (switch_action_timer)
        {
        switch_action_timer--;
        if (switch_action_timer == 0)
            switch_action_done = 0;
        }
    timer_sec++;
    if (timer_sec == 60)
        {
        if (timer_min > 0)
            timer_min--;
        timer_sec=0;
        }
}
