/* An HTTP GET handler - CONFIG */
esp_err_t config_get_handler(httpd_req_t *req)
{   
    ESP_LOGI(TAG, "Config");
    generate_response(CONFIG_MODE);
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

/* An HTTP GET handler - CONFIG */
esp_err_t config_actions_get_handler(httpd_req_t *req)
{   
    char*  buf;
    char param1[3];
    size_t buf_len;    
    buf_len = httpd_req_get_url_query_len(req) + 1;
    ESP_LOGI(TAG, "Config actions");
    if (buf_len > 1)
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK)
            {
            if (httpd_query_key_value(buf, "event", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(event_id,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => event=%s", event_id);
                if (atoi(event_id) > SWITCHLIST_SIZE)
                    itoa(0,event_id,10);
                }
            generate_response(CONFIG_ACTIONS_MODE);
            /* Send response with custom headers and body set as the
            * string passed in user context*/
            const char* resp_str = (const char*) user_str;
            //const char* resp_str = (const char*) req->user_ctx;
            httpd_resp_send(req, resp_str, strlen(resp_str));
        }
    }
    return ESP_OK;
}

esp_err_t cfgsav_get_handler(httpd_req_t *req)
{
    char*  buf;
    char param1[34],param2[66],param3[34],param4[34],param5[18],param6[18],param7[18], param8[4],param9[66], param10[4], param11[18],param12[18],param13[5],param14[5],temp[18],t1[34],t2[66],t3[34],t4[34],t5[18],t6[18],t7[18],t9[66],t11[18],t12[18];
    int isip_t5=0,isip_t6=0,isip_t7=0, isip_t11=0, isip_t12=0,use_dhcp_temp=0,use_auth_temp=0,use_ota_temp=0,use_actions_temp=0,need_reboot=0;
    size_t buf_len;    
    buf_len = httpd_req_get_url_query_len(req) + 1;
    tcpip_adapter_ip_info_t ip_info;
    tcpip_adapter_dns_info_t dns_info;
    cfg_err = 0;
    if (buf_len > 1) 
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK) 
            {
            if (httpd_query_key_value(buf, "SSID", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(t1,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => SSID=%s", t1);
                }
            if (httpd_query_key_value(buf, "password", param2, sizeof(param2)) == ESP_OK) 
                {
                strcpy(t2,url_decode(param2));
                ESP_LOGI(TAG, "Found URL query parameter => password");
                }
            if (httpd_query_key_value(buf, "station", param3, sizeof(param3)) == ESP_OK) 
                {
                strcpy(t3,url_decode(param3));
                ESP_LOGI(TAG, "Found URL query parameter => name=%s", t3);
                }
            if (httpd_query_key_value(buf, "station_password", param4, sizeof(param4)) == ESP_OK) 
                {
                strcpy(t4,url_decode(param4));
                ESP_LOGI(TAG, "Found URL query parameter => station password");
                }
            if (httpd_query_key_value(buf, "ip", param5, sizeof(param5)) == ESP_OK) 
                {
                strcpy(t5,url_decode(param5));
                strcpy(temp,t5);
                isip_t5 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station ip=%s", t5);
                }
            if (httpd_query_key_value(buf, "gw", param6, sizeof(param6)) == ESP_OK) 
                {
                strcpy(t6,url_decode(param6));
                strcpy(temp,t6);
                isip_t6 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station gateway=%s", t6);
                }
            if (httpd_query_key_value(buf, "netmask", param7, sizeof(param7)) == ESP_OK) 
                {
                strcpy(t7,url_decode(param7));
                strcpy(temp,t7);
                isip_t7 = isIp_v4(temp);
                ESP_LOGI(TAG, "Found URL query parameter => station netmask=%s", t7);
                }
            if (httpd_query_key_value(buf, "use_dhcp", param8, sizeof(param8)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => use_dhcp=%s",param8);
                if (strcmp(url_decode(param8),"yes") == 0)
                    use_dhcp_temp = 1;
                }
             if (httpd_query_key_value(buf, "station_new_password_1", param9, sizeof(param9)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => station_new_password_1");
                strcpy(t9,url_decode(param9));
                }  
             if (httpd_query_key_value(buf, "use_password", param10, sizeof(param10)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => use_password=%s", param10);
                if (strcmp(url_decode(param10),"yes") == 0)
                    use_auth_temp = 1;
                }
             if (httpd_query_key_value(buf, "dns1", param11, sizeof(param11)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => DNS1=%s", param11);
                strcpy(t11,url_decode(param11));
                strcpy(temp,t11);
                isip_t11 = isIp_v4(temp);
                }
             if (httpd_query_key_value(buf, "dns2", param12, sizeof(param12)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => DNS2=%s", param12);
                strcpy(t12,url_decode(param12));
                strcpy(temp,t12);
                isip_t12 = isIp_v4(temp);
                if (isip_t12 == 0)
                    strcpy(t12,t11);
                }
            if (httpd_query_key_value(buf, "auto_ota", param13, sizeof(param13)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => auto_ota=%s",param13);
                if (strcmp(url_decode(param13),"yes") == 0)
                    use_ota_temp = 1;
                }
            if (httpd_query_key_value(buf, "use_actions", param14, sizeof(param14)) == ESP_OK) 
                {
                ESP_LOGI(TAG, "Found URL query parameter => use_actions=%s",param14);
                if (strcmp(url_decode(param14),"yes") == 0)
                    use_actions_temp = 1;
                }
            if ( (strlen(t1) > 1 && strlen(t1) <= 32) && strlen(t2) <= 64 && (strlen(t3) > 1 && strlen(t3) <= 32) && (use_dhcp_temp || (isip_t5 && isip_t6 && isip_t7 && isip_t11)) && (strlen(t9) > 1 && strlen(t9) <= 64)  && strcmp (t4, config.station_password) == 0)
                {
                /*update time */
                time(&now);
                localtime_r(&now, &timeinfo);
                strftime(strftime_buf, sizeof(strftime_buf), "%c", &timeinfo);
                strcat(strftime_buf," / config!");
                //Wlan ID
                if (strcmp(config.ssid,t1) != 0)
                    {
                    need_reboot = 1;
                    strcpy(config.ssid,t1);
                    }
                //Wlan Password
                if (strcmp (t2, "current password") != 0)
                    {
                    need_reboot = 1;
                    strcpy(config.password,t2);
                    }
                //IP Data
                if (use_dhcp_temp)
                    {
                    if (strcmp(config.use_dhcp,"no") == 0)
                        need_reboot = 1;
                    strcpy(config.use_dhcp,"yes");
                    //just to have the actual network data, we will store them within the config
                    tcpip_adapter_get_ip_info(TCPIP_ADAPTER_IF_STA, &ip_info);
                    tcpip_adapter_get_dns_info(TCPIP_ADAPTER_IF_STA, TCPIP_ADAPTER_DNS_MAIN, &dns_info);
                    ip4addr_ntoa_r(&ip_info.ip,config.ip, sizeof(config.ip));
                    ip4addr_ntoa_r(&ip_info.gw,config.gw, sizeof(config.gw));
                    ip4addr_ntoa_r(&ip_info.netmask,config.netmask, sizeof(config.netmask));
                    ip4addr_ntoa_r(&dns_info.ip,config.dns1, sizeof(config.dns1));
                    tcpip_adapter_get_dns_info(TCPIP_ADAPTER_IF_STA, TCPIP_ADAPTER_DNS_BACKUP, &dns_info);
                    ip4addr_ntoa_r(&dns_info.ip,config.dns2, sizeof(config.dns2));
                    }
                else
                    {
                    if (strcmp(config.use_dhcp,"yes") == 0)
                        need_reboot = 1;
                    strcpy(config.use_dhcp,"no");
                    if (strcmp(config.ip,t5) != 0)
                        {
                        need_reboot = 1;
                        strcpy(config.ip,t5);
                        }
                    if (strcmp(config.gw,t6) != 0)
                        {
                        need_reboot = 1;
                        strcpy(config.gw,t6);
                        }
                    if (strcmp(config.netmask,t7) != 0)
                        {
                        need_reboot = 1;                        
                        strcpy(config.netmask,t7);
                        }
                    if (strcmp(config.dns1,t11) != 0)
                        {
                        need_reboot = 1;                        
                        strcpy(config.dns1,t11);
                        }
                    if (strcmp(config.dns2,t12) != 0)
                        {
                        need_reboot = 1;                        
                        strcpy(config.dns2,t12);
                        }
                    }
                //Station Name
                if (strcmp(config.name,t3) != 0)
                    strcpy(config.name,t3);
                //Station Password
                if (strcmp (t9, "current password") != 0)
                    strcpy(config.station_password,t9);
                //Use authorization for switches
                if (use_auth_temp)
                    strcpy(config.use_authorization,"yes");
                else
                    strcpy(config.use_authorization,"no");
                if (use_ota_temp && strcmp(OTA_SERVER_URL,"") != 0 && strcmp(OTA_SERVER_CERT,"") != 0)
                    {
                    strcpy(config.auto_ota,"yes");
                    need_reboot = 1;
                    }
                else
                    strcpy(config.auto_ota,"no");
                if (use_actions_temp)
                    strcpy(config.use_actions,"yes");
                else
                    strcpy(config.use_actions,"no");
                if (need_reboot)
                    {
                    restart_in_progress = 1;
                    generate_response(CONFIG_SAVE);
                    const char* resp_str = (const char*) user_str;
                    httpd_resp_send(req, resp_str, strlen(resp_str));
                    vTaskDelay(500);
                    config_write(PORT_OFF);
                    hw_timer_deinit();
                    esp_wifi_disconnect();
                    esp_restart();
                    }
                else
                    {
                    generate_response(CONFIG_SAVE);
                    const char* resp_str = (const char*) user_str;
                    httpd_resp_send(req, resp_str, strlen(resp_str));
                    config_write(status);
                    }
                }
            else
                {
                if (!(strlen(t1) > 1 && strlen(t1) <= 32))
                    cfg_err = cfg_err | (1 << 1);
                if (strlen(t2) > 64)
                    cfg_err = cfg_err | (1 << 2);
                if (!(strlen(t3) > 1 && strlen(t3) <= 32))
                    cfg_err = cfg_err | (1 << 3);
                if (strcmp (t4, config.station_password) != 0)
                    cfg_err = cfg_err | (1 << 4);
                if ((isip_t5 == 0 || isip_t6 == 0 || isip_t7 == 0 || isip_t11 == 0) && use_dhcp_temp == 0)
                    cfg_err = cfg_err | (1 << 5); 
                if (!(strlen(t9) > 1 && strlen(t9) <= 64))
                    cfg_err = cfg_err | (1 << 6);
                generate_response(CONFIG_FAILED);
                const char* resp_str = (const char*) user_str;
                httpd_resp_send(req, resp_str, strlen(resp_str));
                }
            }
        else
            {
            generate_response(CONFIG_FAILED); 
            const char* resp_str = (const char*) user_str;          
            httpd_resp_send(req, resp_str, strlen(resp_str));
            }
        free(buf);
        }
    return ESP_OK;
}

esp_err_t cfgsav_actions_get_handler(httpd_req_t *req)
{
    char*  buf;
    char param1[4],param2[10],param3[3],param4[3],param5[3],param6[8],param7[3],param8[6],param9[66],t1[4],t2[10],t3[3],t4[3],t5[3],t6[8],t7[3],t8[6],t9[66];
    int weekday=9,hour=24,min=60,daynr=0,monthnr=0,event_recur_tmp=0,event_id_tmp,succesfull=0,found_duplicate=SWITCHLIST_SIZE+1,i=0;
    event_id_tmp = atoi(event_id);
    size_t buf_len;    
    buf_len = httpd_req_get_url_query_len(req) + 1;
    ESP_LOGI(TAG, "Config actions");
    if (buf_len > 1)
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK)
            {
            if (httpd_query_key_value(buf, "event_active", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(t1,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => event_active=%s", t1);
                }
            if (httpd_query_key_value(buf, "day", param2, sizeof(param2)) == ESP_OK) 
                {
                strcpy(t2,url_decode(param2));
                ESP_LOGI(TAG, "Found URL query parameter => day=%s", t2);
                if (strcmp(t2,"") != 0)
                    weekday = get_day_number(t2);
                else
                    weekday=9;
                }
            if (httpd_query_key_value(buf, "time_hour", param3, sizeof(param3)) == ESP_OK) 
                {
                strcpy(t3,url_decode(param3));
                ESP_LOGI(TAG, "Found URL query parameter => time_hour=%s", t3);
                hour = atoi(t3);
                }
            if (httpd_query_key_value(buf, "time_min", param4, sizeof(param4)) == ESP_OK) 
                {
                strcpy(t4,url_decode(param4));
                ESP_LOGI(TAG, "Found URL query parameter => time_min=%s", t4);
                min = atoi (t4);
                }
            if (httpd_query_key_value(buf, "switch_status", param5, sizeof(param5)) == ESP_OK) 
                {
                strcpy(t5,url_decode(param5));
                ESP_LOGI(TAG, "Found URL query parameter => switch_status=%s", t5);
                }
            if (httpd_query_key_value(buf, "event_recurring", param6, sizeof(param6)) == ESP_OK) 
                {
                strcpy(t6,url_decode(param6));
                ESP_LOGI(TAG, "Found URL query parameter => event_recurring=%s", t6);
                if (strcmp(t6,"once") == 0)
                    event_recur_tmp = RECUR_ONCE;
                else if (strcmp(t6,"daily") == 0)
                    event_recur_tmp = RECUR_DAY;  
                else if (strcmp(t6,"weekly") == 0)
                    event_recur_tmp = RECUR_WEEK; 
                else if (strcmp(t6,"monthly") == 0)
                    event_recur_tmp = RECUR_MONTH;
                else if (strcmp(t6,"yearly") == 0)
                    event_recur_tmp = RECUR_YEAR;
                else
                    event_recur_tmp = 0;
                }
            if (event_recur_tmp == RECUR_ONCE)
                {
                if (httpd_query_key_value(buf, "daynr_once", param7, sizeof(param7)) == ESP_OK) 
                    {
                    strcpy(t7,url_decode(param7));
                    daynr = atoi(t7);
                    ESP_LOGI(TAG, "Found URL query parameter => daynr_once=%i", daynr);
                    }
                if (httpd_query_key_value(buf, "monthnr_once", param8, sizeof(param8)) == ESP_OK) 
                    {
                    strcpy(t8,url_decode(param8));
                    monthnr = get_month_number(t8);
                    ESP_LOGI(TAG, "Found URL query parameter => monthnr_once=%i", monthnr);
                    }
                }
            else if (event_recur_tmp == RECUR_MONTH)
                {
                if (httpd_query_key_value(buf, "daynr_month", param7, sizeof(param7)) == ESP_OK) 
                    {
                    strcpy(t7,url_decode(param7));
                    daynr = atoi(t7);
                    ESP_LOGI(TAG, "Found URL query parameter => daynr_month=%i", daynr);
                    }
                }                
            else if (event_recur_tmp == RECUR_YEAR)
                {
                if (httpd_query_key_value(buf, "daynr_year", param7, sizeof(param7)) == ESP_OK) 
                    {
                    strcpy(t7,url_decode(param7));
                    daynr = atoi(t7);
                    ESP_LOGI(TAG, "Found URL query parameter => daynr_year=%i", daynr);
                    }
                if (httpd_query_key_value(buf, "monthnr_year", param8, sizeof(param8)) == ESP_OK) 
                    {
                    strcpy(t8,url_decode(param8));
                    monthnr = get_month_number(t8);
                    ESP_LOGI(TAG, "Found URL query parameter => monthnr_year=%i", monthnr);
                    }
                }
            else
                daynr = 1;

            if (httpd_query_key_value(buf, "station_password", param9, sizeof(param9)) == ESP_OK) 
                {
                strcpy(t9,url_decode(param9));
                ESP_LOGI(TAG, "Found URL query parameter => station_password");
                }
            }
        }
    if (hour < 25 && min < 60 && weekday < 9 && event_recur_tmp && daynr < 32 && monthnr < 13 && (strcmp(config.use_authorization,"no") == 0 || strcmp(t9,config.station_password) == 0))
        {
        if (!((monthnr == 2 && daynr > 29) || ((monthnr == 4 || monthnr == 6 || monthnr == 9 || monthnr == 11) && daynr == 31)))
            {
            if (hour == 24)
                hour = 0;
            //this finds duplicate events
            for (i=0;i<SWITCHLIST_SIZE;i++)
                {
                if (i != event_id_tmp && switch_times[i].tm_min == min && switch_times[i].tm_hour == hour && switch_times[i].recurring == event_recur_tmp && switch_times[i].tm_daynr == daynr && switch_times[i].tm_monthnr == monthnr && switch_times[i].tm_wday == weekday)
                    {
                    found_duplicate = i;
                    break;
                    }
                }
            if (found_duplicate == SWITCHLIST_SIZE + 1)
                {
                switch_times[event_id_tmp].recurring = event_recur_tmp;
                switch_times[event_id_tmp].tm_wday = weekday;
                switch_times[event_id_tmp].tm_daynr = daynr;
                switch_times[event_id_tmp].tm_monthnr = monthnr;
                switch_times[event_id_tmp].tm_hour = hour;
                switch_times[event_id_tmp].tm_min = min;
                if (strcmp(t5,"on") == 0)
                    switch_times[event_id_tmp].switch_status = PORT_ON;
                else
                    switch_times[event_id_tmp].switch_status = PORT_OFF;
                if (strcmp(t1,"yes") == 0)
                    switch_times[event_id_tmp].event_status = 1;
                else
                    switch_times[event_id_tmp].event_status = 0;
                enum { N = SWITCHLIST_SIZE };
                //generate sorted actions list
                qsort(switch_times, N, sizeof(time_struct), qsort_helper);
                config_write(status);
                generate_response(status); 
                succesfull = 1;
                }
            }
        }
    if (succesfull == 0)
        {
        if (found_duplicate == SWITCHLIST_SIZE + 1)
            generate_response(CONFIG_ACTIONS_FAILED); 
        else
            {
            //show us data of the duplicate event.
            itoa(found_duplicate,event_id,10);
            generate_response(CONFIG_ACTIONS_FAILED_DUP);
            }
        }
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));
    return ESP_OK;
}

/* An HTTP GET handler - PORTON */
esp_err_t switch_get_handler(httpd_req_t *req)
{
    char*  buf;
    size_t buf_len;  
    char param1[4],param2[4],param3[66],t1[4],t2[4],t3[66];
    buf_len = httpd_req_get_url_query_len(req) + 1;
    cfg_err = 0;
    //do port switch, if auth is needed check password
    if (buf_len > 1) 
        {
        buf = malloc(buf_len);
        if (httpd_req_get_url_query_str(req, buf, buf_len) == ESP_OK) 
            {
            if (httpd_query_key_value(buf, "station_password", param3, sizeof(param3)) == ESP_OK) 
                {
                strcpy(t3,url_decode(param3));
                ESP_LOGI(TAG, "Found URL query parameter => station_password");
                }
            if (httpd_query_key_value(buf, "timer_value", param2, sizeof(param2)) == ESP_OK) 
                {
                strcpy(t2,url_decode(param2));
                timer_min = atoi(t2);
                ESP_LOGI(TAG, "Found URL query parameter => timer_value=%i", timer_min);
                }
            if (httpd_query_key_value(buf, "new_state", param1, sizeof(param1)) == ESP_OK) 
                {
                strcpy(t1,url_decode(param1));
                ESP_LOGI(TAG, "Found URL query parameter => new_state=%s", t1);
                }
            }
        if (strcmp(config.use_authorization,"no") == 0)
            {
            if (strcmp(t1,"on") == 0)
                port_switch(PORT_ON);
            else if (strcmp(t1,"tim") == 0 && timer_min > 0)
                {
                if (timer_min > 960)
                    timer_min = 960;
                port_switch(PORT_TIMER);
                hw_timer_init(hw_timer_callback1, NULL);
                hw_timer_alarm_us(1000000, true);
                timer_sec = 0;
                }
            else if (strcmp(t1,"off") == 0)
                port_switch(PORT_OFF);
            }
            
        else if (strcmp(t3,config.station_password) == 0)
            {
            if (strcmp(t1,"on") == 0)
                port_switch(PORT_ON);
            else if (strcmp(t1,"tim") == 0 && timer_min > 0)
                {
                if (timer_min > 960)
                    timer_min = 960;
                port_switch(PORT_TIMER);
                hw_timer_init(hw_timer_callback1, NULL);
                hw_timer_alarm_us(1000000, true);
                timer_sec = 0;
                }
            else if (strcmp(t1,"off") == 0)
                port_switch(PORT_OFF);
            }
        }
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

/* An HTTP GET handler - ROOT */
esp_err_t root_get_handler(httpd_req_t *req)
{
    generate_response(status);
    /* Send response with custom headers and body set as the
     * string passed in user context*/
    const char* resp_str = (const char*) user_str;
    //const char* resp_str = (const char*) req->user_ctx;
    httpd_resp_send(req, resp_str, strlen(resp_str));

    return ESP_OK;
}

/* start the web server */
httpd_handle_t start_webserver(void)
{
    httpd_handle_t server = NULL;
    httpd_config_t config = HTTPD_DEFAULT_CONFIG();

    // Start the httpd server
    ESP_LOGI(TAG, "Starting server on port: '%d'", config.server_port);
    if (httpd_start(&server, &config) == ESP_OK) 
        {
        // Set URI handlers
        ESP_LOGI(TAG, "Registering URI handlers");
        httpd_register_uri_handler(server, &config_uri);
        httpd_register_uri_handler(server, &config_actions_uri);
        httpd_register_uri_handler(server, &cfgsav_uri);
        httpd_register_uri_handler(server, &cfgsav_actions_uri);
        httpd_register_uri_handler(server, &switch_uri);
        httpd_register_uri_handler(server, &root_uri);
        return server;
        }

    ESP_LOGI(TAG, "Error starting server!");
    return NULL;
}

/* stop webserver */
void stop_webserver(httpd_handle_t server)
{
    // Stop the httpd server
    httpd_stop(server);
}




